# -*- encoding: utf-8 -*
from django.shortcuts import render_to_response, redirect, get_object_or_404
from django.template import Context, RequestContext

from django.utils import simplejson
from auf.django.emploi import models as emploi
from auf.django.emploi import forms as emploiForms
from restkit import request as req
import datamaster_modeles.models as ref

class API:
    def __init__(self, request):
        self.request = request

    def offre_emploi_liste(self):
        url = "http://127.0.0.1:8000/api/offre_emploi_liste/"
        r = req(url)
        liste_json = r.body_string()
        liste_offres = simplejson.loads(liste_json)
        obj_offres_emploi = []

        for offre_dict in liste_offres:
            offre = emploi.OffreEmploi()
            offre.est_affiche = offre_dict['est_affiche']
            offre.statut = offre_dict['statut']
            offre.nom = offre_dict['nom']
            offre.resume = offre_dict['resume']
            offre.description = offre_dict['description']
            offre.poste_nom = offre_dict['poste_nom']
            offre.date_limite = offre_dict['date_limite'] 
            offre.region = ref.Region.objects.get(id=offre_dict['region'])
            offre.bureau = ref.Bureau.objects.get(id=offre_dict['bureau'])
            offre.duree_affectation = offre_dict['duree_affectation']
            offre.renumeration = offre_dict['renumeration']
            offre.debut_affectation = offre_dict['debut_affectation']
            offre.lieu_affectation = ref.Implantation.objects.get(id=offre_dict['lieu_affectation'])
            obj_offres_emploi.append(offre)  
        return obj_offres_emploi

    def offre_emploi(self, offre_id):
        url = "http://127.0.0.1:8000/api/offre_emploi/?id=%s"
        r = req(url % (offre_id))
        offre_json = r.body_string()
        offre_dict = simplejson.loads(offre_json)
        obj_offres_emploi = []

        offre = emploi.OffreEmploi()
        offre.est_affiche = offre_dict['est_affiche']
        offre.statut = offre_dict['statut']
        offre.nom = offre_dict['nom']
        offre.resume = offre_dict['resume']
        offre.description = offre_dict['description']
        offre.poste_nom = offre_dict['poste_nom']
        offre.date_limite = offre_dict['date_limite']
        offre.region = ref.Region.objects.get(id=offre_dict['region'])
        offre.bureau = ref.Bureau.objects.get(id=offre_dict['bureau'])
        offre.duree_affectation = offre_dict['duree_affectation']
        offre.renumeration = offre_dict['renumeration']
        offre.debut_affectation = offre_dict['debut_affectation']
        offre.lieu_affectation = ref.Implantation.objects.get(id=offre_dict['lieu_affectation'])
        obj_offres_emploi.append(offre)
        return obj_offres_emploi

    def candidat_add(self, offre_id):
        url = "http://127.0.0.1:8000/api/candidat_add/?id=%s" % (offre_id)
        return redirect(url)

        
